Index: /trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 376)
@@ -240,18 +240,19 @@
 			}
 
-			if (above != curr.getNameItem() && above != curr.getTitleItem())
+			// Need to do things differently for FORMAT than for DROPPING
+			if (moveAll && above != curr.getNameItem()
+					&& above != curr.getTitleItem()) {
 				x = above.getX();
+				from.setY((int) above.getPolygon().getBounds().getMaxY()
+						+ space
+						+ ((int) (from.getY() - from.getPolygon().getBounds()
+								.getMinY())));
+				from.setX(x);
+			} else {
+				x = from.getX();
+			}
 
 			space += adjust;
-
-			from.setY((int) above.getPolygon().getBounds().getMaxY()
-					+ space
-					+ ((int) (from.getY() - from.getPolygon().getBounds()
-							.getMinY())));
-
-			if (moveAll)
-				from.setX(x);
-		}
-
+		}
 		for (int i = 1; i < toAlign.size(); i++) {
 			Item current = toAlign.get(i);
@@ -580,109 +581,119 @@
 		// check for all tags setting user values
 		for (Text item : profile.getBodyTextItems(false)) {
-
-			AttributeValuePair avp = new AttributeValuePair(item.getText());
-			String attributeFullCase = avp.getAttributeOrValue();
-
-			if (attributeFullCase == null)
-				continue;
-			String attribute = attributeFullCase.toLowerCase();
-
-			if (attribute.equals("homeframe")) {
-				String first = getLink(item, UserSettings.HomeFrame);
-				// do not use non-existant frames as the first frame
-				if (FrameIO.isValidFrameName(first)) {
-					UserSettings.HomeFrame = first;
-				}
-				// warn the user
-				else {
-					// MessageBay.warningMessage("Home frame: " + first
-					// + " is not a valid frame.");
-					UserSettings.HomeFrame = profile.getName();
-				}
-			} else if (attribute.equals("username")) {
-				UserSettings.UserName = avp.getValue();
-			} else if (attribute.equals("spellchecker")) {
-
-				try {
-					JSpellChecker.create();
-				} catch (FileNotFoundException e) {
-					MessageBay.errorMessage("Could not find dictionary: "
-							+ e.getMessage());
-				} catch (IOException e) {
-					// TODO Auto-generated catch block
-					e.printStackTrace();
-				}
-			} else if (attribute.equals("defaultframe"))
-				UserSettings.DefaultFrame = getLink(item,
-						UserSettings.DefaultFrame);
-			else if (attribute.equals("mailsettings"))
-				MailSession.init(item.getChild());
-			else if (attribute.equals("networksettings"))
-				FrameShare.init(item.getChild());
-			else if (attribute.equals("greenstonesettings")) {
-				SearchGreenstone.init(item.getChild());
-			} else if (attribute.equals("reminders"))
-				Reminders.init(item.getChild());
-			else if (attribute.equals("antialias"))
-				UserSettings.AntiAlias = avp.getBooleanValue();
-			else if (attribute.equals("gravity"))
-				UserSettings.Gravity = avp.getIntegerValue();
-			else if (attribute.equals("showlinehighlight"))
-				UserSettings.LineHighlight = avp.getBooleanValue();
-			else if (attribute.equals("linestraightenthreshold"))
-				UserSettings.LineStraightenThreshold = avp.getIntegerValue();
-			else if (attribute.equals("noopthreshold"))
-				UserSettings.NoOpThreshold = avp.getIntegerValue();
-			else if (attribute.equals("formatspacingmin")) {
-				FrameUtils.MINIMUM_SPACING_RATIO = avp.getDoubleValue();
-			} else if (attribute.equals("formatspacingmax")) {
-				FrameUtils.MAXIMUM_SPACING_RATIO = avp.getDoubleValue();
-			} else if (attribute.equals("initialwidth")) {
-				UserSettings.InitialWidth = avp.getIntegerValue();
-			} else if (attribute.equals("initialheight")) {
-				UserSettings.InitialHeight = avp.getIntegerValue();
-			} else if (attribute.equals("titleposition")) {
-				UserSettings.TitlePosition = avp.getIntegerValue();
-			} else if (attribute.equals("logging")) {
-				UserSettings.Logging = avp.getBooleanValue();
-			} else if (attribute.equals("itemtemplate")) {
-				UserSettings.ItemTemplate = ((Text) item).getTemplateForm();
-			} else if (attribute.equals("annotationtemplate")) {
-				UserSettings.AnnotationTemplate = ((Text) item)
-						.getTemplateForm();
-			} else if (attribute.equals("statstemplate")) {
-				UserSettings.StatTemplate = ((Text) item).getTemplateForm();
-			} else if (attribute.equals("commenttemplate")) {
-				UserSettings.CodeCommentTemplate = ((Text) item)
-						.getTemplateForm();
-			} else if (attribute.equals("dottemplate")) {
-				UserSettings.DotTemplate = ((Text) item).getTemplateForm();
-			} else if (attribute.equals("framesetdir")) {
-				String dir = getDir(avp.getValue());
-				if (dir != null) {
-					UserSettings.FrameDirs.add(dir);
-				}
-			} else if (attribute.equals("logdir")) {
-				org.expeditee.gui.FrameIO.LOGS_DIR = getDir(avp.getValue());
-			} else if (attribute.equals("imagedir")) {
-				String dir = getDir(avp.getValue());
-				if (dir != null)
-					UserSettings.ImageDirs.add(0, dir);
-			} else if (attribute.equals("threading")) {
-				UserSettings.Threading = avp.getBooleanValue();
-			} else if (attribute.equals("colorwheel")) {
-				Item.COLOR_WHEEL = getColorWheel(item);
-			} else if (attribute.equals("fillcolorwheel")) {
-				Item.FILL_COLOR_WHEEL = getColorWheel(item);
-			} else if (attribute.equals("backgroundcolorwheel")) {
-				Frame.COLOR_WHEEL = getColorWheel(item);
-			} else if (attribute.equals("framesetdirs")) {
-				UserSettings.FrameDirs.addAll(getDirs(item));
-			} else if (attribute.equals("imagedirs")) {
-				UserSettings.ImageDirs.addAll(getDirs(item));
-			} else if (attribute.equals("style")) {
-				UserSettings.Style = getStyle(item.getChild());
-			} else {
-				errors.add(attributeFullCase + " is not a profile frame tag");
+			try {
+
+				AttributeValuePair avp = new AttributeValuePair(item.getText());
+				String attributeFullCase = avp.getAttributeOrValue();
+
+				if (attributeFullCase == null)
+					continue;
+				String attribute = attributeFullCase.toLowerCase();
+
+				if (attribute.equals("homeframe")) {
+					String first = getLink(item, UserSettings.HomeFrame);
+					// do not use non-existant frames as the first frame
+					if (FrameIO.isValidFrameName(first)) {
+						UserSettings.HomeFrame = first;
+					}
+					// warn the user
+					else {
+						// MessageBay.warningMessage("Home frame: " + first
+						// + " is not a valid frame.");
+						UserSettings.HomeFrame = profile.getName();
+					}
+				} else if (attribute.equals("username")) {
+					UserSettings.UserName = avp.getValue();
+				} else if (attribute.equals("spellchecker")) {
+
+					try {
+						JSpellChecker.create();
+					} catch (FileNotFoundException e) {
+						MessageBay.errorMessage("Could not find dictionary: "
+								+ e.getMessage());
+					} catch (IOException e) {
+						// TODO Auto-generated catch block
+						e.printStackTrace();
+					}
+				} else if (attribute.equals("defaultframe"))
+					UserSettings.DefaultFrame = getLink(item,
+							UserSettings.DefaultFrame);
+				else if (attribute.equals("mailsettings"))
+					MailSession.init(item.getChild());
+				else if (attribute.equals("networksettings"))
+					FrameShare.init(item.getChild());
+				else if (attribute.equals("spelling"))
+					JSpellChecker.create(item.getChild());
+				else if (attribute.equals("greenstonesettings")) {
+					SearchGreenstone.init(item.getChild());
+				} else if (attribute.equals("reminders"))
+					Reminders.init(item.getChild());
+				else if (attribute.equals("antialias"))
+					UserSettings.AntiAlias = avp.getBooleanValue();
+				else if (attribute.equals("gravity"))
+					UserSettings.Gravity = avp.getIntegerValue();
+				else if (attribute.equals("showlinehighlight"))
+					UserSettings.LineHighlight = avp.getBooleanValue();
+				else if (attribute.equals("linestraightenthreshold"))
+					UserSettings.LineStraightenThreshold = avp
+							.getIntegerValue();
+				else if (attribute.equals("noopthreshold"))
+					UserSettings.NoOpThreshold = avp.getIntegerValue();
+				else if (attribute.equals("formatspacingmin")) {
+					FrameUtils.MINIMUM_SPACING_RATIO = avp.getDoubleValue();
+				} else if (attribute.equals("formatspacingmax")) {
+					FrameUtils.MAXIMUM_SPACING_RATIO = avp.getDoubleValue();
+				} else if (attribute.equals("initialwidth")) {
+					UserSettings.InitialWidth = avp.getIntegerValue();
+				} else if (attribute.equals("initialheight")) {
+					UserSettings.InitialHeight = avp.getIntegerValue();
+				} else if (attribute.equals("titleposition")) {
+					UserSettings.TitlePosition = avp.getIntegerValue();
+				} else if (attribute.equals("logging")) {
+					UserSettings.Logging = avp.getBooleanValue();
+				} else if (attribute.equals("itemtemplate")) {
+					UserSettings.ItemTemplate = ((Text) item).getTemplateForm();
+				} else if (attribute.equals("annotationtemplate")) {
+					UserSettings.AnnotationTemplate = ((Text) item)
+							.getTemplateForm();
+				} else if (attribute.equals("statstemplate")) {
+					UserSettings.StatTemplate = ((Text) item).getTemplateForm();
+				} else if (attribute.equals("commenttemplate")) {
+					UserSettings.CodeCommentTemplate = ((Text) item)
+							.getTemplateForm();
+				} else if (attribute.equals("dottemplate")) {
+					UserSettings.DotTemplate = ((Text) item).getTemplateForm();
+				} else if (attribute.equals("framesetdir")) {
+					String dir = getDir(avp.getValue());
+					if (dir != null) {
+						UserSettings.FrameDirs.add(dir);
+					}
+				} else if (attribute.equals("logdir")) {
+					org.expeditee.gui.FrameIO.LOGS_DIR = getDir(avp.getValue());
+				} else if (attribute.equals("imagedir")) {
+					String dir = getDir(avp.getValue());
+					if (dir != null)
+						UserSettings.ImageDirs.add(0, dir);
+				} else if (attribute.equals("threading")) {
+					UserSettings.Threading = avp.getBooleanValue();
+				} else if (attribute.equals("colorwheel")) {
+					Item.COLOR_WHEEL = getColorWheel(item);
+				} else if (attribute.equals("fillcolorwheel")) {
+					Item.FILL_COLOR_WHEEL = getColorWheel(item);
+				} else if (attribute.equals("backgroundcolorwheel")) {
+					Frame.COLOR_WHEEL = getColorWheel(item);
+				} else if (attribute.equals("framesetdirs")) {
+					UserSettings.FrameDirs.addAll(getDirs(item));
+				} else if (attribute.equals("imagedirs")) {
+					UserSettings.ImageDirs.addAll(getDirs(item));
+				} else if (attribute.equals("style")) {
+					UserSettings.Style = getStyle(item.getChild());
+				} else {
+					errors.add(attributeFullCase
+							+ " is not a profile frame tag");
+				}
+			} catch (Exception e) {
+				e.printStackTrace();
+				errors.add("Error parsing [" + item.getText() + "] on "
+						+ profile.getName());
 			}
 		}
@@ -692,4 +703,7 @@
 
 	private static List<Text> getStyle(Frame child) {
+		if (child == null)
+			return new LinkedList<Text>();
+
 		List<Text> style = new ArrayList<Text>(8);
 		for (int i = 0; i < 10; i++) {
@@ -750,10 +764,13 @@
 			return alt;
 
-		String value = new AttributeValuePair(item.getText()).getValue().trim();
-		if (value.length() > 0) {
-			item.setLink(value);
-			return value;
-		} else if (item.getLink() != null)
-			return item.getLink();
+		AttributeValuePair avp = new AttributeValuePair(item.getText());
+		assert (avp != null);
+		
+		if (avp.hasPair()) {
+			item.setLink(avp.getValue());
+			return avp.getValue();
+		} else if (item.getLink() != null) {
+			return item.getAbsoluteLink();
+		}
 
 		return alt;
@@ -1125,4 +1142,10 @@
 	}
 
+	public static Item onItem(float floatX, float floatY,
+			boolean changeLastEdited) {
+		return onItem(DisplayIO.getCurrentFrame(), floatX, floatY,
+				changeLastEdited);
+	}
+
 	/**
 	 * Searches through the list of items on this frame to find one at the given
@@ -1135,5 +1158,6 @@
 	 * @return The Item at the given coordinates, or NULL if none is found.
 	 */
-	public static Item onItem(Frame toCheck, float floatX, float floatY) {
+	public static Item onItem(Frame toCheck, float floatX, float floatY,
+			boolean bResetLastEdited) {
 		// System.out.println("MouseX: " + floatX + " MouseY: " + floatY);
 		int x = Math.round(floatX);
@@ -1172,14 +1196,16 @@
 			// otherwise, the mouse is on the frame
 		} else {
-			if (LastEdited != null && /*
-										 * LastEdited.isVisible() &&
-										 */LastEdited.contains(x, y)
-					&& !FreeItems.getInstance().contains(LastEdited)
-					&& LastEdited.getParent() == DisplayIO.getCurrentFrame()
-					&& LastEdited.getParent().getItems().contains(LastEdited)) {
-				LastEdited.setPermission(Permission.full);
-				return LastEdited;
-			} else {
-				setLastEdited(null);
+			if (LastEdited != null) {
+				if (LastEdited.contains(x, y)
+						&& !FreeItems.getInstance().contains(LastEdited)
+						&& LastEdited.getParent() == DisplayIO
+								.getCurrentFrame()
+						&& LastEdited.getParent().getItems().contains(
+								LastEdited)) {
+					LastEdited.setPermission(Permission.full);
+					return LastEdited;
+				} else if (bResetLastEdited) {
+					setLastEdited(null);
+				}
 			}
 			ArrayList<Item> checkList = new ArrayList<Item>();
@@ -1236,5 +1262,5 @@
 	public synchronized static Item getCurrentItem() {
 		return onItem(DisplayIO.getCurrentFrame(), DisplayIO.getMouseX(),
-				FrameMouseActions.getY());
+				FrameMouseActions.getY(), true);
 	}
 
@@ -1433,9 +1459,9 @@
 
 		yPos += spacing;
-		profile.addText(xPos, yPos, "@HomeFrame: " + profile.getName(), null,
+		profile.addText(xPos, yPos, "@HomeFrame", null,
 				profile.getName());
 		yPos += spacing;
 		String defaultFrameName = profile.getFramesetName() + "0";
-		profile.addText(xPos, yPos, "@DefaultFrame: " + defaultFrameName, null,
+		profile.addText(xPos, yPos, "@DefaultFrame", null,
 				defaultFrameName);
 		yPos += spacing;
@@ -1539,8 +1565,16 @@
 
 	public static void setLastEdited(Text lastEdited) {
+
 		// If the lastEdited is being changed then check if its @i
 		Frame toReparse = null;
 		Frame toRecalculate = null;
-		if (LastEdited != null) {
+		Frame toUpdateObservers = null;
+
+		if (LastEdited == null) {
+			// System.out.print("N");
+		} else if (LastEdited != null) {
+			// System.out.print("T");
+			Frame parent = LastEdited.getParentOrCurrentFrame();
+
 			if (lastEdited != LastEdited) {
 				if (LastEdited.startsWith("@i")) {
@@ -1574,7 +1608,11 @@
 						}
 					}
-					toReparse = LastEdited.getParent();
+					toReparse = parent;
 				} else if (LastEdited.recalculateWhenChanged()) {
-					toRecalculate = LastEdited.getParentOrCurrentFrame();
+					toRecalculate = parent;
+				}
+
+				if (parent.hasObservers()) {
+					toUpdateObservers = parent;
 				}
 				// Update the formula if in XRay mode
@@ -1584,5 +1622,5 @@
 			}
 			if (lastEdited != LastEdited && LastEdited.getText().length() == 0) {
-				LastEdited.getParentOrCurrentFrame().removeItem(LastEdited);
+				parent.removeItem(LastEdited);
 			}
 		}
@@ -1592,6 +1630,12 @@
 			if (toReparse != null) {
 				Parse(toReparse, false, false);
-			} else if (toRecalculate != null) {
-				toRecalculate.recalculate();
+			} else {
+				if (toRecalculate != null) {
+					toRecalculate.recalculate();
+				}
+
+				if (toUpdateObservers != null) {
+					toUpdateObservers.notifyObservers(false);
+				}
 			}
 		}
Index: /trunk/src/org/expeditee/gui/MessageBay.java
===================================================================
--- /trunk/src/org/expeditee/gui/MessageBay.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/MessageBay.java	(revision 376)
@@ -262,5 +262,6 @@
 			boolean displayAlways, String action) {
 		List<String> actions = new LinkedList<String>();
-		actions.add(action);
+		if (action != null)
+			actions.add(action);
 		return displayMessage(message, link, actions, color, displayAlways);
 	}
Index: /trunk/src/org/expeditee/gui/MouseEventRouter.java
===================================================================
--- /trunk/src/org/expeditee/gui/MouseEventRouter.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/MouseEventRouter.java	(revision 376)
@@ -39,7 +39,9 @@
 
 	private Container _contentPane;
-	
+
 	private List<MouseListener> _mouseListeners = new LinkedList<MouseListener>();
+
 	private List<MouseMotionListener> _mouseMotionListeners = new LinkedList<MouseMotionListener>();
+
 	private List<MouseWheelListener> _mouseWheelListeners = new LinkedList<MouseWheelListener>();
 
@@ -50,8 +52,8 @@
 	 * 
 	 * @param menuBar
-	 * 		Must not be null.
+	 *            Must not be null.
 	 * 
 	 * @param contentPane
-	 * 		Must not be null.
+	 *            Must not be null.
 	 */
 	public MouseEventRouter(JMenuBar menuBar, Container contentPane) {
@@ -69,39 +71,44 @@
 		this._contentPane = contentPane;
 	}
-	
+
 	/**
 	 * Listens only to events to frames... i.e. to exeditee, not to widgets.
 	 * 
 	 * @param listener
-	 * 		The listener to add.
+	 *            The listener to add.
 	 */
 	public void addExpediteeMouseListener(MouseListener listener) {
-		if (listener == null) throw new NullPointerException("listener");
+		if (listener == null)
+			throw new NullPointerException("listener");
 		_mouseListeners.add(listener);
 	}
-	
-	
+
 	public void removeExpediteeMouseListener(MouseListener listener) {
-		if (listener == null) throw new NullPointerException("listener");
+		if (listener == null)
+			throw new NullPointerException("listener");
 		_mouseListeners.remove(listener);
 	}
-	
+
 	public void addExpediteeMouseMotionListener(MouseMotionListener listener) {
-		if (listener == null) throw new NullPointerException("listener");
+		if (listener == null)
+			throw new NullPointerException("listener");
 		_mouseMotionListeners.add(listener);
 	}
-	
+
 	public void removeExpediteeMouseMotionListener(MouseMotionListener listener) {
-		if (listener == null) throw new NullPointerException("listener");
+		if (listener == null)
+			throw new NullPointerException("listener");
 		_mouseMotionListeners.remove(listener);
 	}
-	
+
 	public void addExpediteeMouseWheelListener(MouseWheelListener listener) {
-		if (listener == null) throw new NullPointerException("listener");
+		if (listener == null)
+			throw new NullPointerException("listener");
 		_mouseWheelListeners.add(listener);
 	}
-	
+
 	public void removeExpediteeMouseWheelListener(MouseWheelListener listener) {
-		if (listener == null) throw new NullPointerException("listener");
+		if (listener == null)
+			throw new NullPointerException("listener");
 		_mouseWheelListeners.remove(listener);
 	}
@@ -109,8 +116,9 @@
 	/**
 	 * Conceal event catching from outside
+	 * 
 	 * @author Brook Novak
 	 */
 	private class EventCatcher implements AWTEventListener {
-		
+
 		/**
 		 * All events for every component in frame are fired to here
@@ -121,5 +129,5 @@
 			}
 		}
-		
+
 	}
 
@@ -133,7 +141,7 @@
 	 */
 	private void routeMouseEvent(MouseEvent e) {
-		
+
 		_currentMouseEvent = e;
-		
+
 		// First convert the point to expeditee space
 		Point containerPoint = SwingUtilities.convertPoint(e.getComponent(), e
@@ -158,10 +166,12 @@
 			// whether an expeditee item is currently picked up
 			boolean forwardToExpiditee = false;
-			boolean isOverPopup = PopupManager.getInstance().isPointOverPopup(containerPoint);
+			boolean isOverPopup = PopupManager.getInstance().isPointOverPopup(
+					containerPoint);
 			if (isOverPopup) {
 				// Popups have highest preference
 				// forwardToExpiditee = false...
-				
-				// If there ate items in free space - keep them moving with the cursor over the
+
+				// If there ate items in free space - keep them moving with the
+				// cursor over the
 				// popups.
 				if (!FreeItems.getInstance().isEmpty()) {
@@ -169,13 +179,11 @@
 				}
 
-			// Note: all frame.content pane events belong to expeditee
+				// Note: all frame.content pane events belong to expeditee
 			} else if (e.getSource() == _contentPane
 					|| e.getSource() == Browser._theBrowser
 					|| !FreeItems.getInstance().isEmpty()) {
 				forwardToExpiditee = true;
-			} else if (DisplayIO.getCurrentFrame() != null) { // is mouse over
-				// a specific
-				// expeditee
-				// item?
+			} else if (DisplayIO.getCurrentFrame() != null) {
+				/* is mouse over a specific expeditee item? */
 				// NOTE: Do not use FrameUtils.getCurrentItem() - thats relevent
 				// for old mouse position only
@@ -188,11 +196,12 @@
 				// when passing mouse events!!!
 				forwardToExpiditee = (FrameUtils.onItem(DisplayIO
-						.getCurrentFrame(), containerPoint.x, containerPoint.y) != null);
-			}
-			
+						.getCurrentFrame(), containerPoint.x, containerPoint.y,
+						true) != null);
+			}
+
 			// Create artificial mouse event and forward it to expeditee
-			MouseEvent expediteeEvent = SwingUtilities.convertMouseEvent(
-					e.getComponent(), e, _contentPane);
-			
+			MouseEvent expediteeEvent = SwingUtilities.convertMouseEvent(e
+					.getComponent(), e, _contentPane);
+
 			// NOTE: Convert util masks-out the needed extensions
 			MouseEvent withExtensions = null;
@@ -205,9 +214,9 @@
 				switch (e.getID()) {
 				case MouseEvent.MOUSE_MOVED:
-					
+
 					for (MouseMotionListener listener : _mouseMotionListeners) {
 						listener.mouseMoved(expediteeEvent);
 					}
-					
+
 					// Ensure that expiditee has focus only if no popups exist
 					if (Browser._theBrowser != null
@@ -221,27 +230,33 @@
 
 					break;
-					
+
 				case MouseEvent.MOUSE_CLICKED:
-					
-					withExtensions = duplicateMouseEvent(expediteeEvent, e.getModifiers() | e.getModifiersEx());
-					
+
+					withExtensions = duplicateMouseEvent(expediteeEvent, e
+							.getModifiers()
+							| e.getModifiersEx());
+
 					for (MouseListener listener : _mouseListeners) {
 						listener.mouseClicked(withExtensions);
 					}
-					
-					break;
-					
+
+					break;
+
 				case MouseEvent.MOUSE_PRESSED:
-					
-					withExtensions = duplicateMouseEvent(expediteeEvent, e.getModifiers() | e.getModifiersEx());
+
+					withExtensions = duplicateMouseEvent(expediteeEvent, e
+							.getModifiers()
+							| e.getModifiersEx());
 
 					for (MouseListener listener : _mouseListeners) {
 						listener.mousePressed(withExtensions);
 					}
-					
-					break;
-					
+
+					break;
+
 				case MouseEvent.MOUSE_RELEASED:
-					withExtensions = duplicateMouseEvent(expediteeEvent, e.getModifiers() | e.getModifiersEx());
+					withExtensions = duplicateMouseEvent(expediteeEvent, e
+							.getModifiers()
+							| e.getModifiersEx());
 
 					for (MouseListener listener : _mouseListeners) {
@@ -251,5 +266,5 @@
 					break;
 				case MouseEvent.MOUSE_WHEEL:
-					MouseWheelEvent mwe = (MouseWheelEvent)expediteeEvent;
+					MouseWheelEvent mwe = (MouseWheelEvent) expediteeEvent;
 					for (MouseWheelListener listener : _mouseWheelListeners) {
 						listener.mouseWheelMoved(mwe);
@@ -274,5 +289,5 @@
 
 			} else {
-				
+
 				// Keep expeditees mouse X/Y updated
 				FrameMouseActions.MouseX = expediteeEvent.getX();
@@ -283,6 +298,8 @@
 				// to give visual feedback yo users such that swing has focus.
 				Item i = FrameMouseActions.getlastHighlightedItem();
-				if (i != null && i.getHighlightMode() != Item.HighlightMode.None) {
-					FrameGraphics.changeHighlightMode(i, Item.HighlightMode.None);
+				if (i != null
+						&& i.getHighlightMode() != Item.HighlightMode.None) {
+					FrameGraphics.changeHighlightMode(i,
+							Item.HighlightMode.None);
 				}
 
@@ -297,8 +314,11 @@
 						}
 					}
-					// Auto-hide popups when user click on something other other than 
+					// Auto-hide popups when user click on something other other
+					// than
 					// a popup - and is not a on a popup invoker
-				} else if (!isOverPopup && e.getID() == MouseEvent.MOUSE_PRESSED &&
-						!PopupManager.getInstance().isInvoker(e.getComponent())) {
+				} else if (!isOverPopup
+						&& e.getID() == MouseEvent.MOUSE_PRESSED
+						&& !PopupManager.getInstance().isInvoker(
+								e.getComponent())) {
 					PopupManager.getInstance().hideAutohidePopups();
 				}
@@ -327,23 +347,17 @@
 		return false;
 	}
-	
+
 	private MouseEvent duplicateMouseEvent(MouseEvent e, int modifiers) {
-		return new MouseEvent(
-				e.getComponent(), 
-				e.getID(),
-				e.getWhen(),
-				modifiers,
-				e.getX(),
-				e.getY(),
-				/**The below methods are not compatible with Java 1.5*/
-				/*e.getXOnScreen(),
-				e.getYOnScreen(),*/
-				e.getClickCount(),
-				e.isPopupTrigger(),
-				e.getButton());
+		return new MouseEvent(e.getComponent(), e.getID(), e.getWhen(),
+				modifiers, e.getX(), e.getY(),
+				/** The below methods are not compatible with Java 1.5 */
+				/*
+				 * e.getXOnScreen(), e.getYOnScreen(),
+				 */
+				e.getClickCount(), e.isPopupTrigger(), e.getButton());
 	}
 
 	public static MouseEvent getCurrentMouseEvent() {
-		
+
 		return _currentMouseEvent;
 
Index: /trunk/src/org/expeditee/gui/Reminders.java
===================================================================
--- /trunk/src/org/expeditee/gui/Reminders.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/Reminders.java	(revision 376)
@@ -11,4 +11,7 @@
 
 	public synchronized static void init(final Frame reminderFrame) {
+		if(reminderFrame == null)
+			return;
+		
 		for (Text text : reminderFrame.getBodyTextItems(false)) {
 			try {
Index: /trunk/src/org/expeditee/io/AbstractHTMLWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/AbstractHTMLWriter.java	(revision 375)
+++ /trunk/src/org/expeditee/io/AbstractHTMLWriter.java	(revision 376)
@@ -9,4 +9,5 @@
 
 import org.expeditee.gui.Frame;
+import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.MessageBay;
 import org.expeditee.gui.UserSettings;
@@ -23,4 +24,15 @@
 		_format = ".html";
 		super.initialise(start, writer);
+
+		// Clear the filesFolder
+		String filesFolderName = FrameIO.EXPORTS_DIR + getFilesFolder();
+		if (filesFolderName.length() > 0) {
+			File filesFolder = new File(filesFolderName);
+			for (File f : filesFolder.listFiles()) {
+				f.delete();
+			}
+			filesFolder.delete();
+			_filesFolderName = null;
+		}
 
 		_writer.write("<html>" + ItemWriter.NEW_LINE);
Index: /trunk/src/org/expeditee/io/DefaultTreeWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/DefaultTreeWriter.java	(revision 375)
+++ /trunk/src/org/expeditee/io/DefaultTreeWriter.java	(revision 376)
@@ -15,5 +15,5 @@
 
 	private int _indent = 0;
-	
+
 	// the list of frames currently being processed
 	private Stack<FrameCounter> _frames = new Stack<FrameCounter>();
@@ -81,7 +81,10 @@
 
 			Frame next = FrameIO.LoadFrame(cur.frame);
+
 			if (next == null) {
 				return;
 			}
+
+			Text title = next.getTitleItem();
 
 			// the items on the frame currently being processed.
@@ -109,7 +112,11 @@
 				// ignore annotation and framenames
 				if (item.getID() >= 0) {
-					//Only follow the links of text items
-					if (item instanceof Text && item.getLink() != null
-							&& !item.isAnnotation()) {
+					// Only follow the links of non annotation text items
+					boolean followLink = item instanceof Text
+							&& item.getLink() != null
+							&& (!item.isAnnotation() /*|| item.getText()
+									.toLowerCase().equals("@next")*/);
+
+					if (followLink) {
 						cur.index = i;
 						_frames.push(cur);
@@ -139,5 +146,5 @@
 						// Dont write out the title here because it is written
 						// out earlier
-					} else if (item != next.getTitleItem())
+					} else if (item != title)
 						this.writeItem(item);
 				}
@@ -177,5 +184,5 @@
 		}
 	}
-	
+
 	protected int getIndent() {
 		return _indent;
